// AttrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "AttrDlg.h"
#include "rules.h"
#include "WhyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAttrDlg dialog


CAttrDlg::CAttrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAttrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAttrDlg)
	m_name = _T("");
	m_default = _T("");
	m_parms = _T("");
	m_prompt = _T("");
	m_title = _T("");
	//}}AFX_DATA_INIT
}


void CAttrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAttrDlg)
	DDX_Text(pDX, IDC_ATTRID, m_name);
	DDX_Text(pDX, IDC_DEFAULT, m_default);
	DDX_Text(pDX, IDC_PARMS, m_parms);
	DDX_Text(pDX, IDC_QUESTION, m_prompt);
	DDX_Text(pDX, IDC_TITLE, m_title);
	//}}AFX_DATA_MAP
}


BOOL CAttrDlg::OnInitDialog()
{
	Attribute *pAttr;

	CDialog::OnInitDialog();

	if (atr->m_mapStringToAttribute.Lookup(m_name,pAttr)) {
		m_title = pAttr->m_title;
		m_prompt = pAttr->m_prompt;
		m_default = pAttr->m_default;
		m_parms = pAttr->m_parms;
	} else {
		m_title = "";
		m_prompt = "";
		m_default = "";
		m_parms = "";
	}

	UpdateData(false);

	CWnd* pWnd = GetDlgItem(IDC_ATTRID);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CAttrDlg, CDialog)
	//{{AFX_MSG_MAP(CAttrDlg)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_HOW, OnHow)
	ON_BN_CLICKED(IDC_WHICH, OnWhich)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAttrDlg message handlers

void CAttrDlg::OnFind() 
{
	Attribute *pAttr;

	UpdateData(true);

	if (atr->m_mapStringToAttribute.Lookup(m_name,pAttr)) {
		m_title = pAttr->m_title;
		m_prompt = pAttr->m_prompt;
		m_default = pAttr->m_default;
		m_parms = pAttr->m_parms;
	} else {
		m_title = "";
		m_prompt = "";
		m_default = "";
		m_parms = "";
	}

	UpdateData(false);	
}

void CAttrDlg::OnSave() 
{
	Attribute *pAttr;

	UpdateData(true);

	if (atr->m_mapStringToAttribute.Lookup(m_name,pAttr)) {
		if (m_title.IsEmpty()) {
			if (MessageBox(_T("Ok to delete attribute?"),m_name,MB_YESNO) == IDYES) {
				atr->m_mapStringToAttribute.RemoveKey(m_name);
				delete pAttr;
				m_name = "";
				m_title = "";
				m_prompt = "";
				m_default = "";
				m_parms = "";
			}
		} else {
			pAttr->m_title = m_title;
			pAttr->m_prompt = m_prompt;
			pAttr->m_default = m_default;
			pAttr->m_parms = m_parms;
		}
	} else {
		if (MessageBox(_T("Ok to add new attribute?"),m_name,MB_YESNO) == IDYES) {
			pAttr = new Attribute();
			pAttr->m_name = m_name;
			pAttr->m_title = m_title;
			pAttr->m_prompt = m_prompt;
			pAttr->m_default = m_default;
			pAttr->m_parms = m_parms;

			Attribute *pTemp = atr->m_mapStringToAttribute[m_name];
			delete pTemp;

			atr->m_mapStringToAttribute[m_name] = pAttr;
		}
	}

	UpdateData(false);	
}

void CAttrDlg::OnHow() 
{
	CWhyDlg *why = new CWhyDlg;

	UpdateData(true);
	xpt->How(m_name,why->m_reason);

	why->DoModal();
	delete why;
}

void CAttrDlg::OnWhich() 
{
	CWhyDlg *why = new CWhyDlg;

	UpdateData(true);
	xpt->Which(m_name,why->m_reason);

	why->DoModal();
	delete why;
}
