// DumpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "DumpDlg.h"
#include "core.h"

#include "sys/types.h"
#include "time.h"

#include "stdlib.h"
#include "stdio.h"
#include "string.h"

extern CAIMLpadApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDumpDlg dialog


CDumpDlg::CDumpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDumpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDumpDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDumpDlg::FillTree()
{
	HTREEITEM hItem;
	char *buf = new char[MAX_BUF_LEN];
	char *pos;
	fpos_t atpos;
	CString str;
	int last = -1;
	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_AIMLTREE);
	
	pTree->DeleteAllItems();

	str = "*** New AIML ***";
	hItem = pTree->InsertItem(str,TVI_ROOT,TVI_SORT);
	pTree->SetCheck(hItem);
	pTree->SetItemData(hItem,0);

	cnt = 1;
	FILE *tmpl = fopen(bot->fntmp,"r");
	while (!feof(tmpl)) {
		fgets(buf,MAX_BUF_LEN,tmpl);
		if (strncmp(buf,"==",2)) continue;
		if (!(pos = strstr(buf + 2,"=="))) continue;
		if (cnt >= MAX_AIML_FILES) break;
		fgetpos(tmpl,&atpos);
		if (strncmp(buf,"==?==",5)) {
			*pos = 0;
			str = buf + 2;
			hItem = pTree->InsertItem(str,TVI_ROOT,TVI_SORT);
			if (last) tpos[last] = atpos;
			last = cnt;
			pTree->SetItemData(hItem,cnt);
			fpos[cnt++] = atpos;
		} else { 
			if (last) tpos[last] = atpos;
			last = 0;
		}
	}
	fgetpos(tmpl,&atpos);
	if (last) tpos[last] = atpos;
	fclose(tmpl);

	UpdateData(false);
}


BOOL CDumpDlg::OnInitDialog()
{
	CString t;
	
	CDialog::OnInitDialog();

	t = bot->fnaiml;
	GetDlgItem(IDC_DUMP_FN)->SetWindowText(t);

	FillTree();

	return false;
}


void CDumpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDumpDlg)
	DDX_Control(pDX, IDC_AIMLTREE, m_aimltree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDumpDlg, CDialog)
	//{{AFX_MSG_MAP(CDumpDlg)
	ON_BN_CLICKED(IDC_DUMP_BROWSE, OnDumpBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDumpDlg message handlers

void CDumpDlg::OnOK() 
{
	GetParent()->BeginWaitCursor();
	dumpaiml(bot->fnaiml,bot->fnpat,bot->fntmp);	
	GetParent()->EndWaitCursor();
	
	CDialog::OnOK();
}

void CDumpDlg::OnDumpBrowse() 
{
	CString fname(bot->fnaiml);

	CString szFilter = "Text Files (*.txt)|*.txt|AIML Files (*.aiml)|*.aiml|All Files (*.*)|*.*||";
	CFileDialog dlg(false, _T("aiml"), fname, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, szFilter, NULL);

	if (dlg.DoModal() == IDCANCEL)	return;


	GetDlgItem(IDC_DUMP_FN)->SetWindowText(dlg.GetPathName());
	sprintf(bot->fnaiml,"%s",dlg.GetPathName());	
}


void CDumpDlg::dumpaiml(char *fname,char *fnpat,char *fntmp)
{
	fpos_t atpos;
	char *lasttop = new char[MAX_LINE_SIZE];
	char *top = new char[MAX_LINE_SIZE];
	char *line = new char[MAX_LINE_SIZE];
	char *buf = new char[MAX_BUF_LEN];
	char *tmp = new char[MAX_BUF_LEN];
	char *at, *pos;
	int i;
	HTREEITEM hItem;
	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_AIMLTREE);

	CStatusBar* status_bar = (CStatusBar *)theApp.GetMainWnd()->GetDlgItem(AFX_IDW_STATUS_BAR);
	status_bar->SetWindowText(_T("Exporting internal database to AIML..."));

	FILE *fout = fopen(fname,"w");
	FILE *aiml = fopen(fnpat,"r");
	FILE *tmpl = fopen(fntmp,"r");

	hItem = pTree->GetRootItem();
	while (hItem != NULL) {
		i = pTree->GetItemData(hItem);
		if (i >= 0 && i < cnt) blnUnchecked[i] = !pTree->GetCheck(hItem);
		hItem = pTree->GetNextSiblingItem(hItem);
	}

	*top = *lasttop = 0;

	fprintf(fout,"<aiml>\n\n");
	while (!feof(aiml)) {
		fgets(line,MAX_LINE_SIZE,aiml);
		if (!(at = strstr(line,"@"))) continue;
		*at = 0;
		strcpy(buf,at + 1);
		rtrim(buf);
		atpos = atoi(buf);
		for (i = 1;i < cnt;i++) if (atpos >= fpos[i] && atpos < tpos[i]) break;
		if (i < cnt) { if (blnUnchecked[i]) continue; }
		else if (blnUnchecked[0]) continue;
		if (at = strstr(line,"[topic]")) {
			strcpy(top,at + 7);
			*at = 0;
			replace(top,"</topic>","");
		} else *top = 0;
		if (at = strstr(line,"[that]")) {
			strcpy(buf,at);
			replace(buf,"[that]","<that>");
			strcpy(at,"</pattern>\n");
			strcat(line,buf);
			if (!strstr(line,"</that>")) strcat(line,"</that>");
		} else strcat(line,"</pattern>");
		fsetpos(tmpl,&atpos);
		fgets(buf,MAX_BUF_LEN,tmpl);
		rtrim(buf);
		expand(buf);
		if (strcmp(top,lasttop)) {
			if (*lasttop) fprintf(fout,"</topic>");
			if (*top) fprintf(fout,"<topic name=\"%s\">\n",top);
		}
		fprintf(fout,"<category>\n<pattern>%s\n",line);
		for (at = buf,pos = tmp;*at;at++) {
			if (!strncmp(at,"<random>",8)      || !strncmp(at,"<condition>",11) ||
			    !strncmp(at,"</condition>",12) || !strncmp(at,"</random>",9)    ||
			    !strncmp(at,"</li>",5)         || !strncmp(at,"</save>",7)      ||
			    !strncmp(at,"</think>",8)      || !strncmp(at,"</system>",9)    ||
			    !strncmp(at,"</gossip>",9)     || !strncmp(at,"<br/>",5)        ||
				!strncmp(at,"<BR/>",5)         || !strncmp(at,"<usesaved/>",11)) {
				while (*at != '>') *pos++ = *at++;
				*pos++ = *at;
				*pos++ = '\n';
			} else *pos++ = *at;
		}
		*pos = 0;
		if (strlen(buf) == strlen(tmp)) {
			fprintf(fout,"<template>%s</template>\n</category>\n\n",tmp);
		} else {
			if (*(pos - 1) != '\n') strcat(tmp,"\n");
			fprintf(fout,"<template>\n%s</template>\n</category>\n\n",tmp);
		}
		strcpy(lasttop,top);
	}
	if (*lasttop) fprintf(fout,"</topic>\n");
	fprintf(fout,"</aiml>\n");

	fclose(aiml);
	fclose(tmpl);
	fclose(fout);
	delete tmp;
	delete buf;
	delete line;
	delete top;
	delete lasttop;

	status_bar->SetWindowText(_T("Exported internal database to AIML."));
}
