/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// FactsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "FactsDlg.h"
#include "FactDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFactsDlg dialog


CFactsDlg::CFactsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFactsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFactsDlg)
	m_case = _T("");
	m_fact = _T("");
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CFactsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFactsDlg)
	DDX_Control(pDX, IDC_FACTLIST, m_facts);
	DDX_Text(pDX, IDC_CASESTATUS, m_case);
	DDX_Text(pDX, IDC_FACTNAME, m_fact);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


void CFactsDlg::FillList()
{
	CString str;
	CString key;
	Fact *pFact;
	Case *pCase = kb->curSub->m_cases.curCase;

	m_facts.ResetContent();

	POSITION pos = pCase->m_facts.m_mapStringToFact.GetStartPosition();
	while (pos != NULL) {
		pCase->m_facts.m_mapStringToFact.GetNextAssoc(pos,key,pFact);
		if (pFact->m_attribute.Right(1) != "_") str.Format(_T("%s=%s"),pFact->m_attribute,pFact->m_value);
		else str.Format(_T("%s%s"),pFact->m_attribute,pFact->m_value);
		m_facts.AddString(str);
	}

	UpdateData(false);
}


BOOL CFactsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FillList();

	CWnd* pWnd = GetDlgItem(IDC_FACTNAME);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CFactsDlg, CDialog)
	//{{AFX_MSG_MAP(CFactsDlg)
	ON_BN_CLICKED(IDC_ASSIGN, OnAssign)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_LBN_SELCHANGE(IDC_FACTLIST, OnSelchangeFactlist)
	ON_LBN_DBLCLK(IDC_FACTLIST, OnDblclkFactlist)
	ON_BN_CLICKED(IDC_DECLARE, OnDeclare)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFactsDlg message handlers

void CFactsDlg::OnAssign() 
{
	char *buf;
	char *i;
	char *j;

	UpdateData(true);

	buf = new char[m_fact.GetLength() + 4];
	sprintf(buf,"%s",m_fact);
	if (i = strstr(buf,"=")) *i++ = 0;
	else {
		for (i = buf;*i && *i != '_';i++);
		if (*i) for (i++;*i && *i != '_';i++);
		if (*i) i++;
		j = new char[strlen(i) + 2];
		strcpy(j,i);
		*i++ = 0;
		strcpy(i,j);
		delete j;
	}
	if (!kb->curSub->m_cases.curCase->m_facts.Find(buf)) {
		if (MessageBox(_T("Ok to add new fact?"),m_fact,MB_YESNO) == IDYES) {
			kb->curSub->m_cases.curCase->m_facts.Add(buf,i);
		}
	} else kb->putValue(buf,i);
	delete buf;

	FillList();
}

void CFactsDlg::OnRemove() 
{
	char *buf;
	char *i;

	UpdateData(true);

	buf = new char[m_fact.GetLength() + 2];
	sprintf(buf,"%s",m_fact);
	if (i = strstr(buf,"=")) *i = 0;
	else {
		for (i = buf;*i && *i != '_';i++);
		if (*i) for (i++;*i && *i != '_';i++);
		if (*i) *(++i) = 0;
	}

	if (kb->curSub->m_cases.curCase->m_facts.Find(buf)) {
		if (MessageBox(_T("Ok to delete fact?"),m_fact,MB_YESNO) == IDYES) {
			m_fact = _T("");
			kb->curSub->m_cases.curCase->m_facts.Remove(buf);
		}
	} else m_fact = _T("");

	delete buf;

	FillList();
}

void CFactsDlg::OnSelchangeFactlist() 
{
	int nIndex = m_facts.GetCurSel();
	if (nIndex != LB_ERR) {
		m_facts.GetText(nIndex,m_fact);
		UpdateData(false);
	}
}

void CFactsDlg::OnDblclkFactlist() 
{
	char *buf;
	char *i;
	CFactDlg *fact;

	int nIndex = m_facts.GetCurSel();
	if (nIndex != LB_ERR) {
		m_facts.GetText(nIndex,m_fact);
		UpdateData(false);
		buf = new char[m_fact.GetLength() + 2];
		sprintf(buf,"%s",m_fact);
		if (i = strstr(buf,"=")) *i = 0;
		else {
			for (i = buf;*i && *i != '_';i++);
			if (*i) for (i++;*i && *i != '_';i++);
			if (*i) *(++i) = 0;
		}
		if (kb->curSub->m_cases.curCase->m_facts.Find(buf)) {
			fact = new CFactDlg;
			fact->kb = kb;
			if (fact->DoModal() == IDOK) {
				FillList();
				m_fact = _T("");
			}
			delete fact;
		}
	}
}

void CFactsDlg::OnDeclare() 
{
	char *buf;
	char *i;
	char *j;

	UpdateData(true);

	buf = new char[m_fact.GetLength() + 4];
	sprintf(buf,"%s",m_fact);
	if (i = strstr(buf,"=")) *i++ = 0;
	else {
		for (i = buf;*i && *i != '_';i++);
		if (*i) for (i++;*i && *i != '_';i++);
		if (*i) i++;
		j = new char[strlen(i) + 2];
		strcpy(j,i);
		*i++ = 0;
		strcpy(i,j);
		delete j;
	}
	kb->putGlobal(buf,i);
	delete buf;
}
