// SearchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "SearchDlg.h"
#include "TargetDlg.h"
#include "core.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg dialog

CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearchDlg)
	m_SearchType = 0;
	m_SearchText = _T("");
	m_SearchThat = _T("");
	//}}AFX_DATA_INIT
}

void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchDlg)
	DDX_Control(pDX, IDC_FOUNDLIST, m_listctrl);
	DDX_CBIndex(pDX, IDC_SEARCHTYPE, m_SearchType);
	DDX_Text(pDX, IDC_SEARCHTEXT, m_SearchText);
	DDX_Text(pDX, IDC_FINDTHAT, m_SearchThat);
	//}}AFX_DATA_MAP
}

void CSearchDlg::FileList()
{
	char *buf = new char[MAX_BUF_LEN];
	char *path = new char[MAX_PATH_LEN];
	char *pos;
	fpos_t atpos;
	CString str;
	int last = -1;
	strcpy(path,fullpath(""));

	cntFiles = 1;
	FILE *tmpl = fopen(bot->fntmp,"r");
	while (!feof(tmpl)) {
		fgets(buf,MAX_BUF_LEN,tmpl);
		if (strncmp(buf,"==",2)) continue;
		if (!(pos = strstr(buf + 2,"=="))) continue;
		if (cntFiles >= MAX_AIML_FILES) break;
		fgetpos(tmpl,&atpos);
		if (strncmp(buf,"==?==",5)) {
			*pos = 0;
			newstr(&pos,buf + 2);
			replace(pos,path,".\\");
			fnames[cntFiles] = pos;
			if (last) tpos[last] = atpos;
			last = cntFiles;
			fpos[cntFiles++] = atpos;
		} else { 
			if (last) tpos[last] = atpos;
			last = 0;
		}
	}
	fgetpos(tmpl,&atpos);
	if (last) tpos[last] = atpos;
	fclose(tmpl);
	delete path;
	delete buf;
}

void CSearchDlg::FillForm()
{
	char *line = new char[MAX_BUF_LEN];
	char *buf = new char[MAX_BUF_LEN];
	CString str;
	char *pos;
	char *wrk;
	char *at;
	long cnt = 0;
	fpos_t atpos;
	bool fnd;
	int item;
	int i;
	char *topic;
	char *that;
	char *star = new char[3];
	strcpy(star,"*");

	GetParent()->BeginWaitCursor();

	int n = m_SearchText.GetLength();
	char *pat = new char[n + 2];
	sprintf(pat,"%s",m_SearchText);
	char *fthat = new char[m_SearchThat.GetLength() + 2];
	sprintf(fthat,"%s",m_SearchThat);

	m_listctrl.DeleteAllItems();
	intCntCats = 0;

	FILE *aiml = fopen(bot->fnpat,"r");
	FILE *tmpl = fopen(bot->fntmp,"r");
	while (!feof(aiml)) {
		fgets(line,MAX_SIZE,aiml);
		cnt++;
		if (!(pos = strstr(line,"@"))) continue;
		switch (m_SearchType) {
			case 0:
				newstr(&wrk,line);
				at = strstr(wrk,"@");
				*at = 0;
				if (at = strstr(wrk,"[topic]")) *at = 0;
				if (at = strstr(wrk,"[that]")) {
					if (*fthat) if (!bot->match(fthat,at + 6,false)) continue;
					*at = 0;
				}
				fnd = bot->match(pat,wrk,false);
				delete wrk;
				break;
			case 1: fnd = !strnicmp(line,pat,n); break;
			case 2: fnd = (stristr(line,pat) > 0); break;
			case 3:
				newstr(&wrk,line);
				at = strstr(wrk,"@");
				rtrim(at);
				*at++ = 0;
				atpos = atol(at);
				fsetpos(tmpl,&atpos);
				fgets(buf,MAX_BUF_LEN,tmpl);
				rtrim(buf);
				expand(buf);
				fnd = (stristr(buf,pat) > 0);
				delete wrk;
				break;
			default: fnd = false;
		}
		if (fnd) {
			rtrim(pos);
			*pos++ = 0;
			atpos = atol(pos);
			if (pos = strstr(line,"[topic]")) {
				topic = pos + 7;
				*pos = 0;
			} else topic = star;
			if (pos = strstr(line,"[that]")) {
				that = pos + 6;
				*pos = 0;
			} else that = star;
			str = line;
			item = m_listctrl.InsertItem(intCntCats,str);
			m_listctrl.SetItemData(item,(DWORD) intCntCats++);
			str = that;
			m_listctrl.SetItemText(item,1,str);
			str = topic;
			m_listctrl.SetItemText(item,2,str);
			fsetpos(tmpl,&atpos);
			fgets(buf,MAX_BUF_LEN,tmpl);
			rtrim(buf);
			expand(buf);
			str = buf;
			m_listctrl.SetItemText(item,3,str);
			for (i = 1;i < cntFiles;i++) if (atpos >= fpos[i] && atpos < tpos[i]) break;
			if (i < cntFiles) str = fnames[i]; else str = "** new **";
			m_listctrl.SetItemText(item,4,str);
		}
	}
	fclose(aiml);
	fclose(tmpl);

	delete star;
	delete buf;
	delete line;
	delete pat;
	delete fthat;

	GetParent()->EndWaitCursor();

	UpdateData(true);
}

BOOL CSearchDlg::OnInitDialog() 
{
	CString str;
//	LVCOLUMN pCol;

	CDialog::OnInitDialog();
	
	m_listctrl.InsertColumn(0,_T("Pattern"),LVCFMT_LEFT,200,0);
	m_listctrl.InsertColumn(1,_T("That"),LVCFMT_LEFT,80,1);
	m_listctrl.InsertColumn(2,_T("Topic"),LVCFMT_LEFT,60,2);
	m_listctrl.InsertColumn(3,_T("Template"),LVCFMT_LEFT,270,3);
	m_listctrl.InsertColumn(4,_T("File"),LVCFMT_LEFT,122,4);
//	pCol.mask = LVCF_FMT;
//	pCol.fmt = LVCFMT_RIGHT;
//	m_listctrl.SetColumn(4,&pCol);

	FileList();

	GetDlgItem(IDC_SEARCHTEXT)->SetFocus();
	
	return FALSE;
}

BEGIN_MESSAGE_MAP(CSearchDlg, CDialog)
	//{{AFX_MSG_MAP(CSearchDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_FOUNDLIST, OnDblclkFoundlist)
	ON_BN_CLICKED(IDC_FIND_CATEGORY, OnFindCategory)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg message handlers

void CSearchDlg::OnFindCategory()
{
	UpdateData(true);

	FillForm();
}

void CSearchDlg::OnDblclkFoundlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int at;
	CTargetDlg *target;

	UpdateData(true);

	POSITION pos = m_listctrl.GetFirstSelectedItemPosition();
	if (pos == NULL) MessageBox(_T("Nothing selected - use first column to select"));
	else {
		while (pos) {
			at = m_listctrl.GetNextSelectedItem(pos);
			target = new CTargetDlg;
			target->bot = bot;
			target->pu = pu;
			target->intAtTarget = -1;
			target->intCntTargets = -1;
			target->m_Pattern = m_listctrl.GetItemText(at,0);
			target->m_That = m_listctrl.GetItemText(at,1);
			target->m_Topic = m_listctrl.GetItemText(at,2);
			target->Template = m_listctrl.GetItemText(at,3);
			target->m_fname = m_listctrl.GetItemText(at,4);
			target->Reply = "";
			if (target->DoModal() == IDOK) FillForm();
			delete target;
		}
	}
	*pResult = 0;
}

void CSearchDlg::OnDestroy() 
{
	int i;

	CDialog::OnDestroy();
	
	for (i = 1;i < cntFiles;i++) delete fnames[i];	
}
