/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// TreeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "TreeDlg.h"
#include "FactDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeDlg dialog


CTreeDlg::CTreeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTreeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTreeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTreeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTreeDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


void CTreeDlg::FillTree()
{
	CString skey;
	POSITION spos;
	Subject *pSubj;
	HTREEITEM hSubj;
	CString ckey;
	POSITION cpos;
	Case *pCase;
	HTREEITEM hCase;
	CString fkey;
	POSITION fpos;
	Fact *pFact;
	CString str;
	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	
	pTree->DeleteAllItems();

	spos = kb->m_mapStringToSubject.GetStartPosition();
	while (spos != NULL) {
		kb->m_mapStringToSubject.GetNextAssoc(spos,skey,pSubj);
		hSubj = pTree->InsertItem(pSubj->m_name,TVI_ROOT,TVI_SORT);
		cpos = pSubj->m_cases.m_mapStringToCase.GetStartPosition();
		while (cpos != NULL) {
			pSubj->m_cases.m_mapStringToCase.GetNextAssoc(cpos,ckey,pCase);
			hCase = pTree->InsertItem(pCase->m_name,hSubj,TVI_SORT);
			fpos = pCase->m_facts.m_mapStringToFact.GetStartPosition();
			while (fpos != NULL) {
				pCase->m_facts.m_mapStringToFact.GetNextAssoc(fpos,fkey,pFact);
				if (pFact->m_attribute.Right(1) != "_") str.Format(_T("%s=%s"),pFact->m_attribute,pFact->m_value);
				else str.Format(_T("%s%s"),pFact->m_attribute,pFact->m_value);
				pTree->InsertItem(str,hCase,TVI_SORT);
			}
		}
	}

	UpdateData(false);
}


BOOL CTreeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FillTree();

//	CWnd* pWnd = GetDlgItem(IDC_TREE);
//	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CTreeDlg, CDialog)
	//{{AFX_MSG_MAP(CTreeDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE, OnDblclkTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeDlg message handlers

void CTreeDlg::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString m_fact;
	char *buf;
	char *i;
	CFactDlg *fact;

	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem != NULL) if(!pTree->ItemHasChildren(hItem)) {
		m_fact = pTree->GetItemText(hItem);
		buf = new char[m_fact.GetLength() + 2];
		sprintf(buf,"%s",m_fact);
		if (i = strstr(buf,"=")) *i = 0;
		else {
			for (i = buf;*i && *i != '_';i++);
			if (*i) for (i++;*i && *i != '_';i++);
			if (*i) *(++i) = 0;
		}
		if (kb->curSub->m_cases.curCase->m_facts.Find(buf)) {
			fact = new CFactDlg;
			fact->kb = kb;
			if (fact->DoModal() == IDOK) FillTree();
			delete fact;
		}
		delete buf;
	}
	*pResult = 0;
}

