/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 * Copyright (c) 2003-2004, Kino Coursey (Mods for CyN)
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#ifndef I_SUPPORT
#define I_SUPPORT

#if _MSC_VER > 1000
#pragma once
#endif


	#include <winsock.h>
	#include <winbase.h>

#define MAX_AIML_FILES 512

#define MAX_RECURSIONS 50

#define MAX_SIZE 65535 // 32768 // 12288 // 32000 24576
#define MAX_BUF_LEN 65535 //32768 // 10240
#define MAX_LINE_SIZE 65535 //32768 // 8192
#define MAX_LOADSTRING 65535 //32768 // 4096
#define MAX_INSTRING 65535 //32768 // 2048
#define MAX_STAR_LEN 1024
#define MAX_VAR_LEN 512
#define MAX_VALUE_LEN 512
#define MAX_PHRASE_LEN 256
#define MAX_PATH_LEN 128
#define MAX_TAG_LEN 512

#define CNIL ((char *)0)

#define SUCCESS  0
#define FAILURE -1

#define WIN32_LEAN_AND_MEAN

// Windows Header Files:
#include <windows.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include "winioctl.h"
#include "time.h"
#include "atlconv.h"

int getclock();
char *getdts(char *buf);
char *getdate(char *buf);
char *gettime(char *buf);
void timestamp(CString str);
void randomize();

char* fullpath(char* a_File);
LPWSTR fullpath(LPWSTR a_File);

bool fexists(char *file);
int random(int max);

bool XMLtag(char *txt,char *tag);
bool XMLvalue(char *tag,char *attr,char *value);
bool XMLnode(char *text,char *tag,char *data,char *endtag);
bool XMLnode2(char *text,char *tag,char *data,char *endtag);

void remove(char *text,char *first,char *last);
bool replace(char *line,char *string1,char *string2);
void split(char *line,char *text,int cnt);
void cleanspace(char *text);
void cleaner(char *text);
void rtrim(char *text);
void fixnewlines(char *line);
void lowercase(char *text);
void uppercase(char *text);
void propercase(char *text);

int strpcmp(char *s1,char *s2);
int stricmp(char *s1,char *s2);
int strnicmp(char *s1,char *s2,int cnt);
char *stristr(char *s1,char *s2);
bool patrns(char *line,char *best);

void expand(char *line);
void compress(char *line);
void setcompress(bool val);

void newstr(char **s1,char *s2);
bool isNumeric(CString s);
//////////////////////////////////////////////////////////
// INITIAL IRC CLIENT ATTEMPT
/////////////////////////////////////////////////////////
struct ircnode {
  char *s;
  ircnode *next;
};

struct in_parsed {
  char sender[124];
  char reciever[24];
  char method[24];
  char answer[24];
  char sendnick[24];
  char sendip[254];
  char senduser[24];
  char text[512];
}; 

int writeit(int server, char *fmt, ...);
char* spacefixer(char *s,char b[1]);
int call_socket (char hostname[254], unsigned short portnum);
in_parsed parseold(char *s);

int ircinit();
int irctick(char *inputbuf);
int ircreply(char *outbuf);

//////////////////////////////////////////////////////////
// INITIAL WWW SERVER ATTEMPT
/////////////////////////////////////////////////////////
#define COMM_BUFFER_SIZE 1024
#define SMALL_BUFFER_SIZE 10

struct ClientInfo
{
	SOCKET client_socket;
	IN_ADDR client_ip;
};

struct HTTPRequestHeader
{
	char method[SMALL_BUFFER_SIZE];
	char url[MAX_STAR_LEN];
	char filepathname[MAX_PATH];
	char httpversion[SMALL_BUFFER_SIZE];
   IN_ADDR client_ip;
    int mime_index;
};


struct MimeAssociation
{
	char *file_ext;
	char *mime;
};

int wwwinit();
int wwwtick(char *inbuf,ClientInfo *ci,HTTPRequestHeader *requestheaderP);
int wwwreply(char *outbuf,ClientInfo *ci,HTTPRequestHeader *requestheaderP);
#endif